//redUniform-slave
//redFrik 2008 gnu gpl v2
//mirf and spi libraries by stefan engelke

#include <util/delay.h>
#include "nRF24L01.h"
#include "spi.c"
#include "mirf.c"

#define FOSC 1000000
#define mirf_PAYLOAD 1
#define master_payload 7

unsigned int adcVal;
uint8_t bufWrite[master_payload];					//data to send to master

int main(void) {
	PORTD= 0b11011000;								//pull-ups for switches
	
	//--adc init
	ADMUX |= (1<<REFS0);							//voltage reference
	ADCSRA |= ((1<<ADPS2)|(1<<ADPS1)|(0<<ADPS0));	//prescaler 64
	ADCSRA |= (1<<ADEN);							//enable adc
	
	//--mirf init
	mirf_init();
	_delay_ms(50);
	sei();
	mirf_config();
	uint8_t buf[5];
	buf[0]= 0b00000111;								//1mbps
	mirf_write_register(RF_SETUP, buf, 1);
	buf[0]= 10;
	buf[1]= 11;
	buf[2]= 12;
	buf[3]= 13;
	buf[4]= 14;
	mirf_set_RADDR(buf);							//rx address
	buf[0]= 20;
	buf[1]= 21;
	buf[2]= 22;
	buf[3]= 23;
	buf[4]= 24;
	mirf_set_TADDR(buf);							//tx address
	
	//--main loop
	uint8_t i;
	for(;;) {
		
		for(i= 0; i<6; i++) {						//read all 6 adc
			ADMUX &= ~0x0f;
			ADMUX |= i;								//set channel
			ADCSRA |= (1<<ADSC);					//start conversion
			while(bit_is_set(ADCSRA, ADSC));		//wait until conversion finished
			adcVal= ADCW;							//read 10bit value
			bufWrite[i]= adcVal>>2;					//scale down to 8bit
		}
		
		bufWrite[6]= PIND&0b11011000;				//read buttons
		mirf_send(bufWrite, master_payload);
		_delay_ms(20);								//wait
	}
	
	return 0;
}
